aboutsummaryrefslogtreecommitdiff
path: root/devscripts
diff options
context:
space:
mode:
authorJeff Crouse <jefftimesten@gmail.com>2013-01-05 15:03:54 -0500
committerJeff Crouse <jefftimesten@gmail.com>2013-01-05 15:03:54 -0500
commit258d5850c91e0d37a36c6bae0a25314f8149b05a (patch)
tree7d87df8436a588a4338a460499d8614006b6254a /devscripts
parent187da2c093ad1013ea714a464e615de9aa773482 (diff)
parent8e5f7618704805caf9fac093e604834237a7965c (diff)
Merge branch 'master' of https://github.com/rg3/youtube-dl
Conflicts: .gitignore LATEST_VERSION Makefile youtube-dl youtube-dl.exe youtube_dl/InfoExtractors.py youtube_dl/__init__.py
Diffstat (limited to 'devscripts')
-rw-r--r--devscripts/bash-completion.in14
-rwxr-xr-xdevscripts/bash-completion.py26
-rwxr-xr-xdevscripts/gh-pages/add-version.py33
-rwxr-xr-xdevscripts/gh-pages/generate-download.py32
-rwxr-xr-xdevscripts/gh-pages/sign-versions.py28
-rwxr-xr-xdevscripts/gh-pages/update-copyright.py21
-rwxr-xr-xdevscripts/make_readme.py20
-rwxr-xr-xdevscripts/release.sh84
-rw-r--r--devscripts/transition_helper.py40
-rw-r--r--devscripts/transition_helper_exe/setup.py12
-rw-r--r--devscripts/transition_helper_exe/youtube-dl.py102
11 files changed, 407 insertions, 5 deletions
diff --git a/devscripts/bash-completion.in b/devscripts/bash-completion.in
new file mode 100644
index 000000000..3b99a9614
--- /dev/null
+++ b/devscripts/bash-completion.in
@@ -0,0 +1,14 @@
+__youtube-dl()
+{
+ local cur prev opts
+ COMPREPLY=()
+ cur="${COMP_WORDS[COMP_CWORD]}"
+ opts="{{flags}}"
+
+ if [[ ${cur} == * ]] ; then
+ COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
+ return 0
+ fi
+}
+
+complete -F __youtube-dl youtube-dl
diff --git a/devscripts/bash-completion.py b/devscripts/bash-completion.py
new file mode 100755
index 000000000..49287724d
--- /dev/null
+++ b/devscripts/bash-completion.py
@@ -0,0 +1,26 @@
+#!/usr/bin/env python
+import os
+from os.path import dirname as dirn
+import sys
+
+sys.path.append(dirn(dirn((os.path.abspath(__file__)))))
+import youtube_dl
+
+BASH_COMPLETION_FILE = "youtube-dl.bash-completion"
+BASH_COMPLETION_TEMPLATE = "devscripts/bash-completion.in"
+
+def build_completion(opt_parser):
+ opts_flag = []
+ for group in opt_parser.option_groups:
+ for option in group.option_list:
+ #for every long flag
+ opts_flag.append(option.get_opt_string())
+ with open(BASH_COMPLETION_TEMPLATE) as f:
+ template = f.read()
+ with open(BASH_COMPLETION_FILE, "w") as f:
+ #just using the special char
+ filled_template = template.replace("{{flags}}", " ".join(opts_flag))
+ f.write(filled_template)
+
+parser = youtube_dl.parseOpts()[0]
+build_completion(parser)
diff --git a/devscripts/gh-pages/add-version.py b/devscripts/gh-pages/add-version.py
new file mode 100755
index 000000000..6af8bb9d8
--- /dev/null
+++ b/devscripts/gh-pages/add-version.py
@@ -0,0 +1,33 @@
+#!/usr/bin/env python3
+
+import json
+import sys
+import hashlib
+import urllib.request
+
+if len(sys.argv) <= 1:
+ print('Specify the version number as parameter')
+ sys.exit()
+version = sys.argv[1]
+
+with open('update/LATEST_VERSION', 'w') as f:
+ f.write(version)
+
+versions_info = json.load(open('update/versions.json'))
+if 'signature' in versions_info:
+ del versions_info['signature']
+
+new_version = {}
+
+filenames = {'bin': 'youtube-dl', 'exe': 'youtube-dl.exe', 'tar': 'youtube-dl-%s.tar.gz' % version}
+for key, filename in filenames.items():
+ print('Downloading and checksumming %s...' %filename)
+ url = 'http://youtube-dl.org/downloads/%s/%s' % (version, filename)
+ data = urllib.request.urlopen(url).read()
+ sha256sum = hashlib.sha256(data).hexdigest()
+ new_version[key] = (url, sha256sum)
+
+versions_info['versions'][version] = new_version
+versions_info['latest'] = version
+
+json.dump(versions_info, open('update/versions.json', 'w'), indent=4, sort_keys=True) \ No newline at end of file
diff --git a/devscripts/gh-pages/generate-download.py b/devscripts/gh-pages/generate-download.py
new file mode 100755
index 000000000..55912e12c
--- /dev/null
+++ b/devscripts/gh-pages/generate-download.py
@@ -0,0 +1,32 @@
+#!/usr/bin/env python3
+import hashlib
+import shutil
+import subprocess
+import tempfile
+import urllib.request
+import json
+
+versions_info = json.load(open('update/versions.json'))
+version = versions_info['latest']
+URL = versions_info['versions'][version]['bin'][0]
+
+data = urllib.request.urlopen(URL).read()
+
+# Read template page
+with open('download.html.in', 'r', encoding='utf-8') as tmplf:
+ template = tmplf.read()
+
+md5sum = hashlib.md5(data).hexdigest()
+sha1sum = hashlib.sha1(data).hexdigest()
+sha256sum = hashlib.sha256(data).hexdigest()
+template = template.replace('@PROGRAM_VERSION@', version)
+template = template.replace('@PROGRAM_URL@', URL)
+template = template.replace('@PROGRAM_MD5SUM@', md5sum)
+template = template.replace('@PROGRAM_SHA1SUM@', sha1sum)
+template = template.replace('@PROGRAM_SHA256SUM@', sha256sum)
+template = template.replace('@EXE_URL@', versions_info['versions'][version]['exe'][0])
+template = template.replace('@EXE_SHA256SUM@', versions_info['versions'][version]['exe'][1])
+template = template.replace('@TAR_URL@', versions_info['versions'][version]['tar'][0])
+template = template.replace('@TAR_SHA256SUM@', versions_info['versions'][version]['tar'][1])
+with open('download.html', 'w', encoding='utf-8') as dlf:
+ dlf.write(template)
diff --git a/devscripts/gh-pages/sign-versions.py b/devscripts/gh-pages/sign-versions.py
new file mode 100755
index 000000000..dd126df52
--- /dev/null
+++ b/devscripts/gh-pages/sign-versions.py
@@ -0,0 +1,28 @@
+#!/usr/bin/env python3
+
+import rsa
+import json
+from binascii import hexlify
+
+versions_info = json.load(open('update/versions.json'))
+if 'signature' in versions_info:
+ del versions_info['signature']
+
+print('Enter the PKCS1 private key, followed by a blank line:')
+privkey = ''
+while True:
+ try:
+ line = input()
+ except EOFError:
+ break
+ if line == '':
+ break
+ privkey += line + '\n'
+privkey = bytes(privkey, 'ascii')
+privkey = rsa.PrivateKey.load_pkcs1(privkey)
+
+signature = hexlify(rsa.pkcs1.sign(json.dumps(versions_info, sort_keys=True).encode('utf-8'), privkey, 'SHA-256')).decode()
+print('signature: ' + signature)
+
+versions_info['signature'] = signature
+json.dump(versions_info, open('update/versions.json', 'w'), indent=4, sort_keys=True) \ No newline at end of file
diff --git a/devscripts/gh-pages/update-copyright.py b/devscripts/gh-pages/update-copyright.py
new file mode 100755
index 000000000..12c2a9194
--- /dev/null
+++ b/devscripts/gh-pages/update-copyright.py
@@ -0,0 +1,21 @@
+#!/usr/bin/env python
+# coding: utf-8
+
+from __future__ import with_statement
+
+import datetime
+import glob
+import io # For Python 2 compatibilty
+import os
+import re
+
+year = str(datetime.datetime.now().year)
+for fn in glob.glob('*.html*'):
+ with io.open(fn, encoding='utf-8') as f:
+ content = f.read()
+ newc = re.sub(u'(?P<copyright>Copyright © 2006-)(?P<year>[0-9]{4})', u'Copyright © 2006-' + year, content)
+ if content != newc:
+ tmpFn = fn + '.part'
+ with io.open(tmpFn, 'wt', encoding='utf-8') as outf:
+ outf.write(newc)
+ os.rename(tmpFn, fn)
diff --git a/devscripts/make_readme.py b/devscripts/make_readme.py
new file mode 100755
index 000000000..7f2ea319c
--- /dev/null
+++ b/devscripts/make_readme.py
@@ -0,0 +1,20 @@
+import sys
+import re
+
+README_FILE = 'README.md'
+helptext = sys.stdin.read()
+
+with open(README_FILE) as f:
+ oldreadme = f.read()
+
+header = oldreadme[:oldreadme.index('# OPTIONS')]
+footer = oldreadme[oldreadme.index('# CONFIGURATION'):]
+
+options = helptext[helptext.index(' General Options:')+19:]
+options = re.sub(r'^ (\w.+)$', r'## \1', options, flags=re.M)
+options = '# OPTIONS\n' + options + '\n'
+
+with open(README_FILE, 'w') as f:
+ f.write(header)
+ f.write(options)
+ f.write(footer)
diff --git a/devscripts/release.sh b/devscripts/release.sh
index 963a6c22b..cf5784e8c 100755
--- a/devscripts/release.sh
+++ b/devscripts/release.sh
@@ -1,11 +1,85 @@
#!/bin/sh
+# IMPORTANT: the following assumptions are made
+# * the GH repo is on the origin remote
+# * the gh-pages branch is named so locally
+# * the git config user.signingkey is properly set
+
+# You will need
+# pip install coverage nose rsa
+
+# TODO
+# release notes
+# make hash on local files
+
+set -e
+
if [ -z "$1" ]; then echo "ERROR: specify version number like this: $0 1994.09.06"; exit 1; fi
version="$1"
if [ ! -z "`git tag | grep "$version"`" ]; then echo 'ERROR: version already present'; exit 1; fi
-if [ ! -z "`git status --porcelain`" ]; then echo 'ERROR: the working directory is not clean; commit or stash changes'; exit 1; fi
-sed -i "s/__version__ = '.*'/__version__ = '$version'/" youtube_dl/__init__.py
-make all
-git add -A
+if [ ! -z "`git status --porcelain | grep -v CHANGELOG`" ]; then echo 'ERROR: the working directory is not clean; commit or stash changes'; exit 1; fi
+if [ ! -f "updates_key.pem" ]; then echo 'ERROR: updates_key.pem missing'; exit 1; fi
+
+echo "\n### First of all, testing..."
+make clean
+nosetests --with-coverage --cover-package=youtube_dl --cover-html test || exit 1
+
+echo "\n### Changing version in version.py..."
+sed -i~ "s/__version__ = '.*'/__version__ = '$version'/" youtube_dl/version.py
+
+echo "\n### Committing CHANGELOG README.md and youtube_dl/version.py..."
+make README.md
+git add CHANGELOG README.md youtube_dl/version.py
git commit -m "release $version"
-git tag -m "Release $version" "$version" \ No newline at end of file
+
+echo "\n### Now tagging, signing and pushing..."
+git tag -s -m "Release $version" "$version"
+git show "$version"
+read -p "Is it good, can I push? (y/n) " -n 1
+if [[ ! $REPLY =~ ^[Yy]$ ]]; then exit 1; fi
+echo
+MASTER=$(git rev-parse --abbrev-ref HEAD)
+git push origin $MASTER:master
+git push origin "$version"
+
+echo "\n### OK, now it is time to build the binaries..."
+REV=$(git rev-parse HEAD)
+make youtube-dl youtube-dl.tar.gz
+wget "http://jeromelaheurte.net:8142/download/rg3/youtube-dl/youtube-dl.exe?rev=$REV" -O youtube-dl.exe || \
+ wget "http://jeromelaheurte.net:8142/build/rg3/youtube-dl/youtube-dl.exe?rev=$REV" -O youtube-dl.exe
+mkdir -p "update_staging/$version"
+mv youtube-dl youtube-dl.exe "update_staging/$version"
+mv youtube-dl.tar.gz "update_staging/$version/youtube-dl-$version.tar.gz"
+RELEASE_FILES=youtube-dl youtube-dl.exe youtube-dl-$version.tar.gz
+(cd update_staging/$version/ && md5sum $RELEASE_FILES > MD5SUMS)
+(cd update_staging/$version/ && sha1sum $RELEASE_FILES > SHA1SUMS)
+(cd update_staging/$version/ && sha256sum $RELEASE_FILES > SHA2-256SUMS)
+(cd update_staging/$version/ && sha512sum $RELEASE_FILES > SHA2-512SUMS)
+git checkout HEAD -- youtube-dl youtube-dl.exe
+
+echo "\n### Signing and uploading the new binaries to youtube-dl.org..."
+for f in $RELEASE_FILES; do gpg --detach-sig "update_staging/$version/$f"; done
+scp -r "update_staging/$version" ytdl@youtube-dl.org:html/downloads/
+rm -r update_staging
+
+echo "\n### Now switching to gh-pages..."
+git checkout gh-pages
+git checkout "$MASTER" -- devscripts/gh-pages/
+git reset devscripts/gh-pages/
+devscripts/gh-pages/add-version.py $version
+devscripts/gh-pages/sign-versions.py < updates_key.pem
+devscripts/gh-pages/generate-download.py
+devscripts/gh-pages/update-copyright.py
+rm -r test_coverage
+mv cover test_coverage
+git add *.html *.html.in update test_coverage
+git commit -m "release $version"
+git show HEAD
+read -p "Is it good, can I push? (y/n) " -n 1
+if [[ ! $REPLY =~ ^[Yy]$ ]]; then exit 1; fi
+echo
+git push origin gh-pages
+
+echo "\n### DONE!"
+rm -r devscripts
+git checkout $MASTER
diff --git a/devscripts/transition_helper.py b/devscripts/transition_helper.py
new file mode 100644
index 000000000..d5ca2d4ba
--- /dev/null
+++ b/devscripts/transition_helper.py
@@ -0,0 +1,40 @@
+#!/usr/bin/env python
+
+import sys, os
+
+try:
+ import urllib.request as compat_urllib_request
+except ImportError: # Python 2
+ import urllib2 as compat_urllib_request
+
+sys.stderr.write(u'Hi! We changed distribution method and now youtube-dl needs to update itself one more time.\n')
+sys.stderr.write(u'This will only happen once. Simply press enter to go on. Sorry for the trouble!\n')
+sys.stderr.write(u'The new location of the binaries is https://github.com/rg3/youtube-dl/downloads, not the git repository.\n\n')
+
+try:
+ raw_input()
+except NameError: # Python 3
+ input()
+
+filename = sys.argv[0]
+
+API_URL = "https://api.github.com/repos/rg3/youtube-dl/downloads"
+BIN_URL = "https://github.com/downloads/rg3/youtube-dl/youtube-dl"
+
+if not os.access(filename, os.W_OK):
+ sys.exit('ERROR: no write permissions on %s' % filename)
+
+try:
+ urlh = compat_urllib_request.urlopen(BIN_URL)
+ newcontent = urlh.read()
+ urlh.close()
+except (IOError, OSError) as err:
+ sys.exit('ERROR: unable to download latest version')
+
+try:
+ with open(filename, 'wb') as outf:
+ outf.write(newcontent)
+except (IOError, OSError) as err:
+ sys.exit('ERROR: unable to overwrite current version')
+
+sys.stderr.write(u'Done! Now you can run youtube-dl.\n')
diff --git a/devscripts/transition_helper_exe/setup.py b/devscripts/transition_helper_exe/setup.py
new file mode 100644
index 000000000..aaf5c2983
--- /dev/null
+++ b/devscripts/transition_helper_exe/setup.py
@@ -0,0 +1,12 @@
+from distutils.core import setup
+import py2exe
+
+py2exe_options = {
+ "bundle_files": 1,
+ "compressed": 1,
+ "optimize": 2,
+ "dist_dir": '.',
+ "dll_excludes": ['w9xpopen.exe']
+}
+
+setup(console=['youtube-dl.py'], options={ "py2exe": py2exe_options }, zipfile=None) \ No newline at end of file
diff --git a/devscripts/transition_helper_exe/youtube-dl.py b/devscripts/transition_helper_exe/youtube-dl.py
new file mode 100644
index 000000000..dbb4c99e1
--- /dev/null
+++ b/devscripts/transition_helper_exe/youtube-dl.py
@@ -0,0 +1,102 @@
+#!/usr/bin/env python
+
+import sys, os
+import urllib2
+import json, hashlib
+
+def rsa_verify(message, signature, key):
+ from struct import pack
+ from hashlib import sha256
+ from sys import version_info
+ def b(x):
+ if version_info[0] == 2: return x
+ else: return x.encode('latin1')
+ assert(type(message) == type(b('')))
+ block_size = 0
+ n = key[0]
+ while n:
+ block_size += 1
+ n >>= 8
+ signature = pow(int(signature, 16), key[1], key[0])
+ raw_bytes = []
+ while signature:
+ raw_bytes.insert(0, pack("B", signature & 0xFF))
+ signature >>= 8
+ signature = (block_size - len(raw_bytes)) * b('\x00') + b('').join(raw_bytes)
+ if signature[0:2] != b('\x00\x01'): return False
+ signature = signature[2:]
+ if not b('\x00') in signature: return False
+ signature = signature[signature.index(b('\x00'))+1:]
+ if not signature.startswith(b('\x30\x31\x30\x0D\x06\x09\x60\x86\x48\x01\x65\x03\x04\x02\x01\x05\x00\x04\x20')): return False
+ signature = signature[19:]
+ if signature != sha256(message).digest(): return False
+ return True
+
+sys.stderr.write(u'Hi! We changed distribution method and now youtube-dl needs to update itself one more time.\n')
+sys.stderr.write(u'This will only happen once. Simply press enter to go on. Sorry for the trouble!\n')
+sys.stderr.write(u'From now on, get the binaries from http://rg3.github.com/youtube-dl/download.html, not from the git repository.\n\n')
+
+raw_input()
+
+filename = sys.argv[0]
+
+UPDATE_URL = "http://rg3.github.com/youtube-dl/update/"
+VERSION_URL = UPDATE_URL + 'LATEST_VERSION'
+JSON_URL = UPDATE_URL + 'versions.json'
+UPDATES_RSA_KEY = (0x9d60ee4d8f805312fdb15a62f87b95bd66177b91df176765d13514a0f1754bcd2057295c5b6f1d35daa6742c3ffc9a82d3e118861c207995a8031e151d863c9927e304576bc80692bc8e094896fcf11b66f3e29e04e3a71e9a11558558acea1840aec37fc396fb6b65dc81a1c4144e03bd1c011de62e3f1357b327d08426fe93, 65537)
+
+if not os.access(filename, os.W_OK):
+ sys.exit('ERROR: no write permissions on %s' % filename)
+
+exe = os.path.abspath(filename)
+directory = os.path.dirname(exe)
+if not os.access(directory, os.W_OK):
+ sys.exit('ERROR: no write permissions on %s' % directory)
+
+try:
+ versions_info = urllib2.urlopen(JSON_URL).read().decode('utf-8')
+ versions_info = json.loads(versions_info)
+except:
+ sys.exit(u'ERROR: can\'t obtain versions info. Please try again later.')
+if not 'signature' in versions_info:
+ sys.exit(u'ERROR: the versions file is not signed or corrupted. Aborting.')
+signature = versions_info['signature']
+del versions_info['signature']
+if not rsa_verify(json.dumps(versions_info, sort_keys=True), signature, UPDATES_RSA_KEY):
+ sys.exit(u'ERROR: the versions file signature is invalid. Aborting.')
+
+version = versions_info['versions'][versions_info['latest']]
+
+try:
+ urlh = urllib2.urlopen(version['exe'][0])
+ newcontent = urlh.read()
+ urlh.close()
+except (IOError, OSError) as err:
+ sys.exit('ERROR: unable to download latest version')
+
+newcontent_hash = hashlib.sha256(newcontent).hexdigest()
+if newcontent_hash != version['exe'][1]:
+ sys.exit(u'ERROR: the downloaded file hash does not match. Aborting.')
+
+try:
+ with open(exe + '.new', 'wb') as outf:
+ outf.write(newcontent)
+except (IOError, OSError) as err:
+ sys.exit(u'ERROR: unable to write the new version')
+
+try:
+ bat = os.path.join(directory, 'youtube-dl-updater.bat')
+ b = open(bat, 'w')
+ b.write("""
+echo Updating youtube-dl...
+ping 127.0.0.1 -n 5 -w 1000 > NUL
+move /Y "%s.new" "%s"
+del "%s"
+ \n""" %(exe, exe, bat))
+ b.close()
+
+ os.startfile(bat)
+except (IOError, OSError) as err:
+ sys.exit('ERROR: unable to overwrite current version')
+
+sys.stderr.write(u'Done! Now you can run youtube-dl.\n')